VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form EditorForm 
   Caption         =   "Editor []"
   ClientHeight    =   4110
   ClientLeft      =   1140
   ClientTop       =   1800
   ClientWidth     =   4575
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4110
   ScaleWidth      =   4575
   Begin MSComDlg.CommonDialog FileDialog 
      Left            =   120
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      CancelError     =   -1  'True
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNew 
         Caption         =   "&New"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As..."
         Shortcut        =   ^A
      End
      Begin VB.Menu mnuSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuTests 
      Caption         =   "&Tests"
      Enabled         =   0   'False
      Begin VB.Menu mnuTestsConvexHull 
         Caption         =   "&Convex Hull"
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuTestsHullCull 
         Caption         =   "&Hull Cull"
         Shortcut        =   {F3}
      End
      Begin VB.Menu mnuTestsAngleValues 
         Caption         =   "&AngleValues"
         Shortcut        =   {F4}
      End
   End
End
Attribute VB_Name = "EditorForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private FileName As String  ' The full file name.
Private FileTitle As String ' The file name without path.

Private DataModified As Boolean

Private m_Drawing As Boolean
Private m_LastX As Long
Private m_LastY As Long

Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long

Private Const RADIUS = 3

Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hwnd As Long, lpPoint As POINTAPI) As Long

Private Sub AddPoint(ByVal X As Long, ByVal Y As Long)
    m_NumPoints = m_NumPoints + 1
    ReDim Preserve m_Points(1 To m_NumPoints)
    With m_Points(m_NumPoints)
        .X = X
        .Y = Y
    End With
End Sub


' Return True if the data is safe.
Private Function DataSafe() As Boolean
    ' No problem if the data is unmodified.
    If Not DataModified Then
        DataSafe = True
        Exit Function
    End If
    
    ' See if the user wants to save changes.
    Select Case MsgBox("The data has been modified. Do you want to save the changes?", _
            vbYesNoCancel)
        Case vbYes
            ' Save the data. Procedure SaveData
            ' will reset DataModified.
            mnuFileSave_Click
            DataSafe = Not DataModified
            
        Case vbNo
            ' Discard the changes to the data.
            DataSafe = True
            
        Case vbNo
            ' Cancel.
            DataSafe = False
    End Select
End Function

' Draw the convex hull.
Public Sub DrawConvexHull()
Dim pt As Integer

    ' Redraw the points.
    Cls
    DrawPoints

    ' Draw the convex hull.
    CurrentX = m_Points(m_NumHullPoints).X
    CurrentY = m_Points(m_NumHullPoints).Y
    For pt = 1 To m_NumHullPoints
        Line -(m_Points(pt).X, m_Points(pt).Y), vbRed
    Next pt
End Sub
' Draw the polygon.
Private Sub DrawPoints()
Dim i As Integer

    Cls
    For i = 1 To m_NumPoints
        Circle (m_Points(i).X, m_Points(i).Y), RADIUS
    Next i
End Sub

' Load data from the file.
Private Sub LoadData(ftitle As String, fname As String)
Dim fnum As Integer
Dim i As Integer

    ' Open the file.
    fnum = FreeFile
    Open fname For Input As fnum

    ' Read the number of points.
    Input #fnum, m_NumPoints
    ReDim m_Points(1 To m_NumPoints)

    ' Read the points.
    For i = 1 To m_NumPoints
        With m_Points(i)
            Input #fnum, .X, .Y
        End With
    Next i

    ' Close the file.
    Close fnum

    ' Save the file name and title.
    FileTitle = ftitle
    FileName = fname

    ' Make sure the caption gets updated.
    DataModified = True
    SetDataChanged False

    ' Draw the new polygon.
    DrawPoints

    ' Enable the Tests menu.
    mnuTests.Enabled = True
End Sub
' Randomize the points for debugging.
Private Sub RandomizePoints()
Dim i As Integer
Dim j As Integer
Dim temp_pt As POINTAPI

    Randomize
    For i = 1 To m_NumPoints - 1
        j = Int((m_NumPoints - i + 1) * Rnd + i)
        temp_pt = m_Points(i)
        m_Points(i) = m_Points(j)
        m_Points(j) = temp_pt
    Next i
End Sub

' Save data into the file.
Private Sub SaveData(ftitle As String, fname As String)
Dim fnum As Integer
Dim i As Integer

    ' Open the file.
    fnum = FreeFile
    Open fname For Output As fnum

    ' Save the number of points.
    Write #fnum, m_NumPoints

    ' Save the points.
    For i = 1 To m_NumPoints
        With m_Points(i)
            Write #fnum, .X, .Y
        End With
    Next i

    ' Close the file.
    Close fnum

    ' Save the file name and title.
    FileTitle = ftitle
    FileName = fname

    ' Make sure the caption gets updated.
    DataModified = True
    SetDataChanged False
End Sub
' Set DataModified. Display an asterisk in the
' form's Caption next to the file name if
' appropriate.
Private Sub SetDataChanged(changed As Boolean)
    ' Don't bother if it's already been done.
    If DataModified = changed Then Exit Sub
    
    DataModified = changed
    If changed Then
        Caption = "Editor*[" & FileTitle & "]"
    Else
        Caption = "Editor [" & FileTitle & "]"
    End If
End Sub

' Set the file dialog's path for the next time.
Private Sub SetDialogPath()
Dim file_path As String
Dim pos As Integer

    file_path = FileDialog.FileName
    file_path = Left$(file_path, Len(file_path) - Len(FileDialog.FileTitle))
    FileDialog.InitDir = file_path
    FileDialog.FileName = FileDialog.FileTitle

    ' Save the directory in the registry.
    SaveSetting App.ProductName, "Directories", _
        "SaveDir", FileDialog.InitDir
End Sub

Private Sub Form_Load()
Dim wid As Single
Dim hgt As Single

    ScaleMode = vbPixels
    AutoRedraw = True

    ' Get the last directory the program accessed.
    ' If there is no entry, use the App.Path.
    FileDialog.InitDir = GetSetting( _
        App.ProductName, "Directories", _
        "SaveDir", App.Path)
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If m_Drawing Then
        ' Already drawing.
        ' Stop or place a point here and continue
        If Button = vbRightButton Then
            ' Stop drawing.
            m_Drawing = False
            DrawMode = vbCopyPen
            DrawPoints

            ' Enable the Tests menu.
            mnuTests.Enabled = True
        Else
            ' Add another point to the polygon.
            Circle (m_LastX, m_LastY), RADIUS
            AddPoint X, Y
            DrawMode = vbCopyPen
            Circle (m_Points(m_NumPoints).X, m_Points(m_NumPoints).Y), RADIUS
            DrawMode = vbInvert
            Circle (m_Points(m_NumPoints).X, m_Points(m_NumPoints).Y), RADIUS

            ' Enable the Tests menu.
            mnuTests.Enabled = True
        End If
    Else
        ' Start drawing.
        m_Drawing = True
        Cls
        m_NumPoints = 1
        ReDim m_Points(1 To m_NumPoints)
        With m_Points(m_NumPoints)
            .X = X
            .Y = Y
        End With
        m_LastX = X
        m_LastY = Y
        Circle (m_LastX, m_LastY), RADIUS

        DrawMode = vbInvert
        Circle (m_LastX, m_LastY), RADIUS

        ' Mark the data as modified.
        SetDataChanged True
    End If
End Sub
Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not m_Drawing Then Exit Sub

    Circle (m_LastX, m_LastY), RADIUS
    m_LastX = X
    m_LastY = Y
    Circle (m_LastX, m_LastY), RADIUS
End Sub


' Make sure the data is safe to unload.
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Cancel = Not DataSafe
End Sub
' Unload the form.
Private Sub mnuFileExit_Click()
    ' Note: The QueryUnload event handler checks
    ' that the data is safe.
    Unload Me
End Sub


' Start a new file.
'
Private Sub mnuFileNew_Click()
    ' Make sure the existing data is safe.
    If Not DataSafe Then Exit Sub

    ' Delete the old polygon.
    m_NumPoints = 0
    DrawPoints

    ' Save the file name and title.
    FileTitle = ""
    FileName = ""

    ' Make sure the caption gets updated.
    DataModified = True
    SetDataChanged False
End Sub
' Open a file.
Private Sub mnuFileOpen_Click()
    ' Make sure the existing data is safe.
    If Not DataSafe Then Exit Sub

    ' Start in the application directory.
    If FileDialog.InitDir = "" Then _
        FileDialog.InitDir = App.Path

    ' Set desired flags.
    FileDialog.Flags = _
        cdlOFNFileMustExist + _
        cdlOFNHideReadOnly + _
        cdlOFNLongNames

    ' Set desired filters.
    FileDialog.Filter = "Points files (*.pts)|*.pts|All Files (*.*)|*.*"
    FileDialog.FilterIndex = 0

    ' Let the user select the file to open.
    On Error Resume Next
    FileDialog.ShowOpen
    If Err.Number = cdlCancel Then
        ' The user canceled.
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error" & Str$(Err.Number) & " selecting file." & _
            vbCrLf & Err.Description
        Exit Sub
    End If
    On Error GoTo 0
    
    ' Set the dialog path for next time.
    SetDialogPath
    
    ' Load the data.
    LoadData FileDialog.FileTitle, FileDialog.FileName
End Sub


' Save using the current file name.
Private Sub mnuFileSave_Click()
    ' If there's no file name, treat as Save As.
    If FileTitle = "" Then
        mnuFileSaveAs_Click
        Exit Sub
    End If
    
    ' Save the data using the current file name.
    SaveData FileTitle, FileName
End Sub

' Save using a new file name.
Private Sub mnuFileSaveAs_Click()
    ' Start in the application directory.
    If FileDialog.InitDir = "" Then _
        FileDialog.InitDir = App.Path

    ' Set desired flags.
    FileDialog.Flags = _
        cdlOFNPathMustExist + _
        cdlOFNHideReadOnly + _
        cdlOFNLongNames

    ' Set desired filters.
    FileDialog.Filter = "Points files (*.pts)|*.pts|All Files (*.*)|*.*"
    FileDialog.FilterIndex = 0

    ' Let the user select the file to open.
    On Error Resume Next
    FileDialog.ShowSave
    If Err.Number = cdlCancel Then
        ' The user canceled.
        Exit Sub
    ElseIf Err.Number <> 0 Then
        MsgBox "Error" & Str$(Err.Number) & " selecting file." & _
            vbCrLf & Err.Description
        Exit Sub
    End If
    On Error GoTo 0

    ' Set the dialog path for next time.
    SetDialogPath

    ' Load the data.
    SaveData FileDialog.FileTitle, FileDialog.FileName
End Sub

' Display point AngleValues. This is mostly for
' debugging the AngleValue function.
Private Sub mnuTestsAngleValues_Click()
Dim pt As POINTAPI
Dim i As Integer
Dim X As Single
Dim Y As Single

    ' Get the mouse position.
    GetCursorPos pt
    ScreenToClient hwnd, pt
    With pt
        X = .X
        Y = .Y
    End With

    ' Clear any previous results.
    Cls
    DrawPoints

    ' Draw the values.
    For i = 1 To m_NumPoints
        With m_Points(i)
            CurrentX = .X
            CurrentY = .Y
            Print Format$(AngleValue(X, Y, .X, .Y), "0")
        End With
    Next i

    ' Draw the pivot point.
    Circle (X, Y), 3, vbRed
End Sub
Private Sub mnuTestsConvexHull_Click()
Dim points_examined As Long

    ' Randomize the points for debugging repeated tests.
    RandomizePoints

    ' Make the convex hull.
    m_NumEligiblePoints = m_NumPoints
    points_examined = MakeConvexHull()

    ' Draw the convex hull.
    DrawConvexHull

    ' Tell the user how many points we examined.
    MsgBox "Examined " & Format$(points_examined) & " points"
End Sub

' Cull points out of the convex hull that lie inside the
' trapezoid defined by the vertices with smallest and
' largest X and Y coordinates.
Private Sub mnuTestsHullCull_Click()
Dim points_examined As Long
Dim iul As Integer
Dim iur As Integer
Dim ill As Integer
Dim ilr As Integer
Dim xmin As Single
Dim xmax As Single
Dim ymin As Single
Dim ymax As Single
Dim i As Integer

    ' Randomize the points for debugging repeated tests.
    RandomizePoints

    ' Cull the points.
    HullCull

    ' Make the convex hull.
    points_examined = MakeConvexHull()

    ' Draw the convex hull.
    DrawConvexHull

    ' Draw the culling corners.
    GetMinMaxCorners iul, iur, ill, ilr
    DrawStyle = vbDot
    Line (m_Points(iul).X, m_Points(iul).Y)-(m_Points(iur).X, m_Points(iur).Y), vbBlue
    Line -(m_Points(ilr).X, m_Points(ilr).Y), vbBlue
    Line -(m_Points(ill).X, m_Points(ill).Y), vbBlue
    Line -(m_Points(iul).X, m_Points(iul).Y), vbBlue
    DrawStyle = vbSolid

    ' Draw the culling box.
    GetMinMaxBox xmin, xmax, ymin, ymax
    Line (xmin, ymin)-(xmax, ymax), vbBlue, B

    ' Color the culled points.
    For i = m_NumEligiblePoints + 1 To m_NumPoints
        Circle (m_Points(i).X, m_Points(i).Y), 3, vbRed
    Next i

    ' Tell the user how many points we examined.
    MsgBox "Examined " & Format$(points_examined) & " points"
End Sub

